<?php
defined( 'ABSPATH' ) or exit;
if ( ! class_exists( 'WES_Admin' ) ) {
    class WES_Admin{
        public function __construct(){
            require_once(WES_PLUGIN_ADMIN_DIR.'/class-admin-ajax.php');
            add_action('admin_menu',[&$this, 'plugin_setup_menu']);
        
        }
        public static function plugin_setup_menu(){
            $settingPage=add_submenu_page('woocommerce', esc_attr__('Mplus Export',WES_TEXT_DOMAIN),esc_attr__('Mplus Export',WES_TEXT_DOMAIN) , 'manage_options', 'woo-export', [__CLASS__,'plugin_settings_init']);
            $startPage=add_submenu_page(
                'options.php'
                 , esc_attr__('Mplus Export',WES_TEXT_DOMAIN)
                 , esc_attr__('Mplus Export',WES_TEXT_DOMAIN)
                 , 'manage_options'
                 , 'woo-export-start'
                 , [__CLASS__,'woo_export_start_callback']
             );
             add_submenu_page(
                'options.php'
                 , esc_attr__('Download CSV',WES_TEXT_DOMAIN)
                 , esc_attr__('Download',WES_TEXT_DOMAIN)
                 , 'manage_options'
                 , 'woo-download-csv'
                 , [__CLASS__,'woo_donwload_csv']
             );
            add_action( 'load-' . $settingPage, [__CLASS__,'load_admin_scripts']);
            add_action( 'load-' . $startPage, [__CLASS__,'load_admin_scripts']);

        }
        public static function woo_donwload_csv(){
            $filePath=get_option('wes_exporter_file_path');
            if(!empty($filePath)){
                if(file_exists($filePath)){
                    $fileName=current_time('Y-m-d').'-woo-export-for-mplus.csv';
                    header('Content-Description: CSV Export');
                    header('Content-Type: text/csv');
                    header("Cache-Control: no-cache, must-revalidate");
                    header("Expires: 0");
                    header('Content-Disposition: attachment; filename="'.$fileName.'"');
                    header('Content-Length: ' . filesize($filePath));
                    header('Pragma: public');
                    ob_clean();
                    flush();
                    readfile($filePath);
                    die();
                    
                }
            }
        }
        public static function load_admin_scripts(){
            add_action( 'admin_enqueue_scripts', [__CLASS__,'admin_scripts'] );
        }
        public static function admin_scripts(){
            wp_enqueue_style('wes-pure-css', WES_PLUGIN_ABSOLUTE_PATH.'assets/css/pure-min.css', [],'2.0.6','all');
            wp_enqueue_style('wes-pure-responsive', WES_PLUGIN_ABSOLUTE_PATH.'assets/css/grids-responsive-min.css',['wes-pure-css'],'2.0.6','all');
            wp_enqueue_style('wes-main', WES_PLUGIN_ABSOLUTE_PATH . 'assets/css/wes.admin.css', [],'1.0.0','all');
            wp_register_script( 'wes_admin_main',WES_PLUGIN_ABSOLUTE_PATH.'assets/js/wes.admin.js' , ['jquery'], time(), true );
            wp_localize_script('wes_admin_main','wes_vars',[
                'ajax_url'=>admin_url('admin-ajax.php'),
                'cancelText'=>esc_attr__('Annuleren',WES_TEXT_DOMAIN),
                'checkVariationText'=>__('Product variaties controleren...',WES_TEXT_DOMAIN),
                'checkVariationSubText'=>__('Als je webshop variaties heeft wordt de SKU/Artikelnummer van het hoofdproduct veranderd naar variation-[variationid]',WES_TEXT_DOMAIN),
                'validateText'=>__('Data controleren...',WES_TEXT_DOMAIN),
                'validateSubText'=>__('Moment geduld aub',WES_TEXT_DOMAIN),
                'startPage'=>esc_attr__(admin_url( 'admin.php?page=woo-export' )),
                'renameVariationText'=>__('We genereren en hernoemen de SKU/Artikelnummers van product variaties...',WES_TEXT_DOMAIN),
                'renameVariableText'=>__('We vervangen de SKU/Artikelnummers van variabele producten...',WES_TEXT_DOMAIN),

                'renameVariationSubText'=>__('Moment geduld aub, we hernoemen de SKU/Artikelnummers van product variaties.',WES_TEXT_DOMAIN),
                'renameVariableSubText'=>__('Moment geduld aub, we hernoemen de SKU/Artikelnummers van variabele productem.',WES_TEXT_DOMAIN),

                'generateSKUText'       =>__('Ontbrekende SKU/Artikelnummers worden gegenereerd...',WES_TEXT_DOMAIN),
                'generateSKUSubText'    =>__('Moment geduld aub, we hernoemen de SKU/Artikelnummers van simple producten.',WES_TEXT_DOMAIN),
                'duplicateSKUText'       =>__('We controleren op dubbele SKU/Artikelnummers...',WES_TEXT_DOMAIN),
                'duplicateSKUTextSubText'    =>__('Moment geduld aub, we controleren of alle producten een unieke SKU/Artikelnummer hebben.',WES_TEXT_DOMAIN),
                'initiateExportText'       =>__('Export wordt voorbereid...',WES_TEXT_DOMAIN),
                'initiateExportSubText'    =>__('Een moment geduld aub, de export wordt gestart.',WES_TEXT_DOMAIN),
                'exportCSVText'            => __('Producten worden geexporteert...',WES_TEXT_DOMAIN),
                'exportCSVSubText'            => __("We exporteren op dit moment alle producten en maken er een .csv export van.",WES_TEXT_DOMAIN),
                'nonces' => [
                    'product_sku'    =>     wp_create_nonce('wes-check-product-sku-nonce'),
                    'variation_sku'    =>  wp_create_nonce('wes-check-variation-sku-nonce'),
                    'validate_data'    =>  wp_create_nonce('wes-validate-all-data-nonce'),
                    'rename_variation'  =>  wp_create_nonce('wes-rename-variation-nonce'),
                    'rename_variable_products'  =>  wp_create_nonce('wes-rename-variaable-products-nonce'),
                    'generate_sku'      =>  wp_create_nonce('wes-generate-sku-nonce'),
                    'duplicate_check'   =>  wp_create_nonce('wes-duplicate-check-nonce'),
                    'initiate_export'   =>  wp_create_nonce('wes-initiate-export-nonce'),
                    'export_product'   =>  wp_create_nonce('wes-export-product-nonce'),

                ],
              
                
            ]);
            wp_enqueue_script('wes_admin_main');

        }
        private static function term_ancestors( $term_id, $taxonomy ) {
            $ancestors = get_ancestors( $term_id, $taxonomy );
            $ancestors = array_reverse( $ancestors );
            $ancestorArray=[];
            foreach ( $ancestors as $ancestor ) {
                $ancestor = get_term( $ancestor, $taxonomy );
    
                if ( ! is_wp_error( $ancestor ) && $ancestor ) {
                 
                   array_push($ancestorArray,$ancestor->name);
                }
            }
            return $ancestorArray;
        }
     
        public static function plugin_settings_init(){
            delete_option('wes_duplicate_product_skus');
            delete_option('wes_product_skus');
            delete_option('wes_empty_product_skus');
            delete_option('wes_variation_skus');
            delete_option('wes_variation_offset');
            delete_option('wes_product_offset');
            delete_option('wes_all_product_sku');
            delete_option('wes_product_export_offset');
          
               ?>
            <div id="woocExporterContainer">
                <p class="wesComnayName">MplusWebshops</p>
                <h1>Woo Exporter</h1>
                <div id="wesCreateExportContainer" class="wesWrapper">
                     <div id="wefCreateButtonContainer" class="wes-border-bottom" >
                     <a class="button button-primary wes-button" href="<?php esc_attr_e(admin_url( 'admin.php?page=woo-export-start' )) ?>"><?php esc_attr_e('Mplus Export maken',WES_TEXT_DOMAIN)?></a>
                     </div>  
                     <div class="wes-footer">
                        <p>
                        <span class="dashicons dashicons-info"></span>
                            <strong>
                            <?php
                            esc_html_e("Maak een BACKUP! voordat je aan de slag gaat. Deze export tool overschrijft alle SKU's van je WooCommerce artikelen en dit kan niet ongedaan worden gemaakt!", WES_TEXT_DOMAIN );
                             ?>
                            </strong>
                        </p>
                     </div> 

                    
                </div>
                <div id="wesExtraInfo" class="pure-g">
                        <div class="pure-u-1 pure-u-md-1-2">
                        <div class="wesInfoBox">
                        <h2><?php esc_html_e('Waarom deze export tool?',WES_TEXT_DOMAIN)?></h2>
                            <p>
                                <?php
                                esc_html_e(
                            "Als je al een WooCommerce webshop hebt en je wilt van start gaan met MplusKASSA dan is het handig om een export uit WooCommerce te kunnen importeren in MplusKASSA. Deze plugin zorgt er voor dat alle Woo producten een geldige en voor MplusKASSA geschikte SKU/Artikelnummer krijgen én bieden je de optie de artikeln in het juiste format te downloaden als .csv bestand."
                                ,WES_TEXT_DOMAIN);
                                ?>
                            </p>
                        </div>
                        </div>
                        <div class="pure-u-1 pure-u-md-1-2">
                            <div class="wesInfoBox">
                            <h2><?php esc_html_e('Hoe ziet de export er uit?',WES_TEXT_DOMAIN)?></h2>
                            <p>
                            <?php
                                esc_html_e(
                            "Hieronder kun je een voorbeeld downloaden van het format van de .csv download die je kunt verwachten."
                                ,WES_TEXT_DOMAIN);
                                ?>
                            </p>
                            <p>
                            <a href="https://mpluswebshops.nl/wp-content/uploads/EXAMPLE-woo-export-for-mplus.csv" target="_blank"><?php esc_attr_e('Voorbeeld export (.csv)',WES_TEXT_DOMAIN)?></a>
                            </p>
                            <h2><?php esc_html_e('Afbeeldingen ook exporteren?',WES_TEXT_DOMAIN)?></h2>
                            <p>
                            <?php
                                esc_html_e(
                            "Wil je ook alle afbeeldingen uit WooCommerce downloaden in een format welke geschikt is voor import in MplusKASSA? Dit kan alleen als je klant bent van MplusWEBSHOPS en kost ons 2 - 4 uur werk. Neem hiervoor contact op met support@yuluma.com."
                                ,WES_TEXT_DOMAIN);
                                ?>
                                </p>
                            </div>
                        </div>
                     </div>
            </div>
            <?php
        }
        public static function woo_export_start_callback(){
           ?>
            <div id="woocExporterContainer">
            <p class="wesComnayName">MplusWebshops</p>

            <h1>WooCommerce MplusKASSA Exporteer tool</h1>
                    <div id="wesCreateExportContainer" class="wesWrapper">
                        <div id="wesExportProgressContainer" class="wesContainer">
                            <ul class="progressbar">
                            <li class="active first"><?php esc_attr_e('Voorwaarden',WES_TEXT_DOMAIN)?></li>
                            <li class="second"><?php esc_attr_e('Controles',WES_TEXT_DOMAIN)?></li>
                            <li class="third"><?php esc_attr_e('Downloaden',WES_TEXT_DOMAIN)?></li>
                            </ul>
                        
                        </div>
                        <div id="wesExportProgressContent">
                            <div id="wesExportWarningContainer" class="wesPrgoressContent active">
                            <h2>
                                <span>
                                <?php esc_attr_e('Waarschuwing',WES_TEXT_DOMAIN) ?>
                                </span>
                                <?php esc_attr_e('Voordat je verder kunt gaan moet je akkoord gaan met het volgende:',WES_TEXT_DOMAIN) ?>
                            </h2>

                            <div id="wesExportCheckboxContainer">
                                <p>
                                <input type="checkbox" class="wesWarningCheckbox" name="Checkbox" id="check_1">
                                <label for="check_1">
                                    <?php
                                    esc_html_e("Je hebt een volledige, complete en actuele backup van je database! Dit script gaat namelijk je SKU/Artikelnummers bijwerken voordat het kan exporteren. Deze plugin kan deze actie niet ongedaan maken. Daarom is een backup noodzakelijk!",WES_TEXT_DOMAIN);
                                     ?>
                                </label>
                                </p>
                                <p>
                                <input type="checkbox" class="wesWarningCheckbox" name="Checkbox2" id="check_2">
                                <label for="check_2">
                                    Je accepteert dat het gebruik van deze plugin volledig voor je eigen risico is.<br>             
                                    <span>De maker van deze plugin <u>kan niet</u> aansprakelijk worden gehouden voor het verlies van data of andere schade aan je website of bedrijfsvoering.</span>
                                    
                                </label>
                                </p>
                            </div>
                            </div>
                            <div id="wesExportPrepareContainer" class="wesPrgoressContent">
                                    <div id="wesPrepareLoader">
                                    <div class="wesloader">Loading...</div>
                                    </div>
                                    <div id="wesProgressBar" class="progress-bar wesHidden">
                                            <span class="progress-bar-fill" style="width: 0%;"></span>
                                    </div>
                                    <div id="wesContentForAjaxProgress">
                                    <h2 class="wesHeading">
                                    <?php esc_attr_e('We controleren je producten op geldige Artikelnummers (SKUs)',WES_TEXT_DOMAIN)?>
                                    </h2>
                                    <p class="wesSubHeading">
                                        <?php 
                                        esc_attr_e('We controleren nu of al je producten in WooCommerce een bruikbare en unieke SKU/Artikelnummer hebben. De duur hangt af van het aantal producten die in WooCommerce staan.',WES_TEXT_DOMAIN);
                                        ?>
                                    </p>
                                        <p class="wesProductCount" style="display: none;">
                                        
                                        </p>
                                    </div>
                                    <div id="wesContentForAjax" class="wesHidden"></div>
                            </div>
                            <div id="wesTableContainer" class="wesHidden"></div>
                        </div>
                        <div class="wes-footer wesBorderTop">
                            <div class="wesFooterButtonContainer">
                            <a href="<?php esc_attr_e(admin_url( 'admin.php?page=woo-export' ));?>" class="wesBackButton"><?php esc_attr_e('Terug',WES_TEXT_DOMAIN)?></a>
                                <button data-continue-text="<?php esc_attr_e('Verder gaan',WES_TEXT_DOMAIN)?>" data-disable-text="<?php esc_attr_e('Ga eerst akkoord om verder te gaan',WES_TEXT_DOMAIN)?>" data-export-text="<?php esc_attr_e('Start Export',WES_TEXT_DOMAIN)?>" data-enable-text="<?php esc_attr_e('Volgende stap',WES_TEXT_DOMAIN)?>" class="wesNextButton wesButton disable button"><?php esc_attr_e('Ga eerst akkoord om verder te gaan',WES_TEXT_DOMAIN)?></button>
                                    <div class="clearfix"></div>
                            </div>
                        </div>
                    </div>    
            </div>    
           <?php
        }
    }
    new WES_Admin();
}