jQuery(function($){
    let wesProgress=1;
    const checkProductSKU=function(){
        var data={
            action:'wes_check_product_sku',
            security:wes_vars.nonces.product_sku
        };
        $.post(wes_vars.ajax_url,data).done(function(response){
            if( response.success ) {
              
               if(typeof response.data!=='undefined' && response.data.done){
                $('#wesPrepareLoader').addClass('wesHidden');
                $('.wesProductCount').hide();
                $('body').trigger('wes_check_variations');
               }else{

               checkProductSKU();
               }
             if(typeof response.data.from !=='undefined' && typeof response.data.to !=='undefined' && typeof response.data.total !='undefined'){
                $('.wesProductCount').html("We vonden <strong>"+response.data.total+"</strong> producten in totaal. Op dit moment checken we <strong>"+response.data.from+"</strong> tot <strong>"+response.data.to+"</strong>")
                 $('.wesProductCount').show();
             }

            } 
        }).fail(function() {
            $('#wesPrepareLoader').addClass('wesHidden');
        });
      
    };
    const checkVariationSKU=function(){
        var data={
            action:'wes_check_variation_sku',
            security:wes_vars.nonces.variation_sku
        };
        $.post(wes_vars.ajax_url,data).done(function(response){
            if( response.success ) {
              
               if(typeof response.data!=='undefined' && response.data.done){
                $('#wesPrepareLoader').addClass('wesHidden');
                $('.wesProductCount').hide();
                $('body').trigger('wes_validate_data');
               }else{
                checkVariationSKU();
               }
               if(typeof response.data.from !=='undefined' && typeof response.data.to !=='undefined' && typeof response.data.total !='undefined'){
                $('.wesProductCount').html("We vonden in totaal <strong>"+response.data.total+"</strong> variaties. Op dit moment controleren we <strong>"+response.data.from+"</strong> tot <strong>"+response.data.to+"</strong>")
                $('.wesProductCount').show();
            }
            } 
        }).fail(function() {
            $('#wesPrepareLoader').addClass('wesHidden');
        });
      
    };
    const validateWesData=function(){
        var data={
            action:'wes_validate_all_data',
            security:wes_vars.nonces.validate_data
        };
        $.post(wes_vars.ajax_url,data).done(function(response){
            $('#wesPrepareLoader').addClass('wesHidden');
            if(response.success){
                $('#wesContentForAjaxProgress').addClass('wesHidden');
                $('#wesContentForAjax').html(response.data.html);
                $('#wesContentForAjax').removeClass('wesHidden');
                if(response.data.isOk){
                    
                    $('.wesNextButton').removeClass('disable').html($('.wesNextButton').data('export-text')).show();
                    $('#wesExportProgressContainer .progressbar .second').removeClass('error').addClass('done');
                }else{
                    $('.wesNextButton').hide();
                    $('#wesExportProgressContainer .progressbar .second').addClass('error');
                }
                if(typeof response.data.tableData !='undefined'){
                    $('#wesTableContainer').html(response.data.tableData).removeClass('wesHidden');
                }else{
                    $('#wesTableContainer').html('').addClass('wesHidden');

                }
                if(typeof response.data.showContinue !='undefined' && response.data.showContinue){
                    $('.wesNextButton').removeClass('disable').addClass('continue_duplicate_check').html($('.wesNextButton').data('continue-text')).show();
                }
            }
        }).fail(function() {
            $('#wesPrepareLoader').addClass('wesHidden');
        });
    };
    $(document).on('wes_validate_data',function(){
        $('#wesPrepareLoader').removeClass('wesHidden');
        $('.wesHeading').html(wes_vars.validateText);
        $('.wesSubHeading').html(wes_vars.validateSubText);
        validateWesData();
    });
    $(document).on('wes_check_variations',function(){
        $('#wesPrepareLoader').removeClass('wesHidden');
        $('.wesHeading').html(wes_vars.checkVariationText);
        $('.wesSubHeading').html(wes_vars.checkVariationSubText);
        checkVariationSKU();

    })

   $(document).on('change','.wesWarningCheckbox',function(){
    var numberOfChecked = $('.wesWarningCheckbox:checked').length;
   
        if(numberOfChecked==2){
            $('.wesNextButton').removeClass('disable').addClass('button-primary').text($('.wesNextButton').data('enable-text'));
            $('#wesExportProgressContainer .progressbar .first').addClass('done');
        }else{
            $('.wesNextButton').addClass('disable').removeClass('button-primary').text($('.wesNextButton').data('disable-text'));
            $('#wesExportProgressContainer .progressbar .first').removeClass('done')


        }
   });
   const checkDuplicateSKU=function(){
    $('#wesContentForAjax').addClass('wesHidden');
    $('#wesTableContainer').addClass('wesHidden');
    $('#wesContentForAjaxProgress').removeClass('wesHidden');
    $('.wesNextButton').removeClass('continue_duplicate_check').hide();
    $('#wesPrepareLoader').removeClass('wesHidden');
    $('.wesHeading').html(wes_vars.duplicateSKUText);
    $('.wesSubHeading').html(wes_vars.duplicateSKUTextSubText);
    var data={
        action:'wes_check_duplicate_sku',
        security:wes_vars.nonces.duplicate_check
    };
    $.post(wes_vars.ajax_url,data).done(function(response){
        if(response.success){
            
            $('body').trigger('wes_validate_data');
        }
        $('#wesPrepareLoader').addClass('wesHidden');
    });
   }
   const exportProduct=function(){
    var data={
        action:'wes_export_product',
        security:wes_vars.nonces.export_product
    };
    $.post(wes_vars.ajax_url,data).done(function(response){
        if( response.success ) {
          
           if(typeof response.data!=='undefined' && response.data.done){
         
           $('#wesContentForAjaxProgress').addClass('wesHidden');
                $('#wesContentForAjax').html(response.data.html);
                $('#wesContentForAjax').removeClass('wesHidden');
                $('#wesPrepareLoader').addClass('wesHidden');
                $('#wesProgressBar').addClass('wesHidden');
                $('#wesExportProgressContainer .progressbar .third').removeClass('error').addClass('done');
                $('.wesNextButton').remove();
                $('.wesBackButton').remove();
                $('<a href="'+wes_vars.startPage+'" class="wesStartAnotherExport">Begin opnieuw</a>').appendTo($('.wesFooterButtonContainer'));
                $('#wesContentForAjax').html(response.data.html);
           }else{
            exportProduct();
           }
           if(typeof response.data.percentage!=='undefined'){
               $('.progress-bar-fill').css({'width':response.data.percentage+'%'});
           }

        } 
    }).fail(function() {
        $('#wesPrepareLoader').addClass('wesHidden');
    });
   }
   let totalProducts=0;
   $(document).on('click','.wesNextButton',function(e){
       e.preventDefault();
       const self=$(this);
       if(self.hasClass('disable')) return false;
       if(self.hasClass('continue_duplicate_check')){
           checkDuplicateSKU();
           return false;
       }
       wesProgress+=1;
       if(wesProgress==2){
           $('.wesPrgoressContent').removeClass('active');
           $('#wesExportPrepareContainer').addClass('active');
           $('#wesExportProgressContainer .progressbar .second').addClass('active');
           $('.wesBackButton').text(wes_vars.cancelText); 
            checkProductSKU();
           $('.wesNextButton').hide();
       }
       if(wesProgress==3){
        $('#wesContentForAjax').addClass('wesHidden');
        $('#wesContentForAjaxProgress').removeClass('wesHidden');
        $('#wesPrepareLoader').removeClass('wesHidden');
        $('.wesHeading').html(wes_vars.initiateExportText);
        $('.wesSubHeading').html(wes_vars.initiateExportSubText);
        $('#wesExportProgressContainer .progressbar .third').removeClass('error').addClass('active');
        self.hide();
        var data={
            action:'wes_initiate_export',
            security:wes_vars.nonces.initiate_export
        };
        $.post(wes_vars.ajax_url,data).done(function(response){
            if(response.success){
                $('.wesHeading').html(wes_vars.exportCSVText);
                $('.wesSubHeading').html(wes_vars.exportCSVSubText);
                if(typeof response.totalData!=='undefined') totalProducts=response.totalData;
                $('#wesProgressBar').removeClass('wesHidden');
                exportProduct();

            }
        });
       }
   });
   $(document).on('click','#wesRenameVariationSku',function(e){
    $('#wesContentForAjax').addClass('wesHidden');
    $('#wesContentForAjaxProgress').removeClass('wesHidden');
    $('#wesPrepareLoader').removeClass('wesHidden');
    $('.wesHeading').html(wes_vars.renameVariationText);
    $('.wesSubHeading').html(wes_vars.renameVariationSubText);
    var data={
        action:'wes_rename_variation',
        security:wes_vars.nonces.rename_variation
    };
    $.post(wes_vars.ajax_url,data).done(function(response){
        if(response.success){
            
            $('body').trigger('wes_validate_data');
        }
        $('#wesPrepareLoader').addClass('wesHidden');
    });
   });
   $(document).on('click','#wesRenameVariableSku',function(e){
    $('#wesContentForAjax').addClass('wesHidden');
    $('#wesContentForAjaxProgress').removeClass('wesHidden');
    $('#wesPrepareLoader').removeClass('wesHidden');
    $('.wesHeading').html(wes_vars.renameVariableText);
    $('.wesSubHeading').html(wes_vars.renameVariableSubText);
    var data={
        action:'wes_rename_variable_products',
        security:wes_vars.nonces.rename_variable_products
    };
    $.post(wes_vars.ajax_url,data).done(function(response){
        if(response.success){
            
            $('body').trigger('wes_validate_data');
        }
        $('#wesPrepareLoader').addClass('wesHidden');
    });
   });
   $(document).on('click','#wesGenerateSKU',function(e){
    $('#wesContentForAjax').addClass('wesHidden');
    $('#wesContentForAjaxProgress').removeClass('wesHidden');
    $('#wesPrepareLoader').removeClass('wesHidden');
    $('.wesHeading').html(wes_vars.renameVariationText);
    $('.wesSubHeading').html(wes_vars.renameVariationSubText);
    var data={
        action:'wes_generate_sku',
        security:wes_vars.nonces.generate_sku
    };
    $.post(wes_vars.ajax_url,data).done(function(response){
        if(response.success){
            
            $('body').trigger('wes_validate_data');
        }
        $('#wesPrepareLoader').addClass('wesHidden');
    });
   });
   $(document).on('click','#wesDownloadCsv',function(){
       const target=$(this).data('target');
       window.location.replace(target);

   })
});
